#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define MAXN 255

using namespace std;

int mini[MAXN][MAXN][MAXN];

void Resi(int n, int r, int c, int q, int** u, int** v, int** w,
            int* x1, int* y1, int* x2, int* y2, int* o){

    for(int i=1;i<=r;i++){
        for(int p=1;p<=c;p++){
            mini[i][p][p]=w[i][p];
            for(int j=p+1;j<=c;j++){

                mini[i][p][j]=min(mini[i][p][j-1],w[i][j]);
            }
        }
    }
    for(int qq=1;qq<=q;qq++){
        int res=65537;

        for(int i=x1[qq];i<=x2[qq];i++)
            res=min(res,mini[i][y1[qq]][y2[qq]]);
        //printf("  %d\n",res);
        o[qq]=res;
    }

    return;


}